﻿using System;
using System.Collections.Generic;
using System.Text;

namespace FDK
{
	public class CFPS : IDisposable
	{
		public int n現在のFPS
		{
			get;
			protected set;
		}
		public bool bFPSの値が変化した
		{
			get;
			protected set;
		}

		public CFPS()
		{
			this.n現在のFPS = 0;
			this.n内部FPS = 0;
			this.bFPSの値が変化した = false;
			this.m一定間隔処理 = new C一定間隔処理();
		}
		public void tカウンタ更新()
		{
			this.bFPSの値が変化した = false;

			this.m一定間隔処理.t進行( 1000, () => {

				this.n現在のFPS = this.n内部FPS;
				this.n内部FPS = 0;
				this.bFPSの値が変化した = true;
			} );

			this.n内部FPS++;
		}

		#region [ IDisposable 実装 ]
		//-----------------
		public void Dispose()
		{
			C共通.tDisposeする( ref this.m一定間隔処理 );
		}
		//-----------------
		#endregion

		#region [ protected ]
		//-----------------
		protected C一定間隔処理 m一定間隔処理;
		protected int n内部FPS;
		//-----------------
		#endregion
	}
}
