﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using SlimDX;
using SlimDX.Direct3D9;

namespace FDK
{
	public class CMActフェードアウト・透明度 : CActivity
	{
		public bool b完了
		{
			get;
			protected set;
		}
		
		public void t開始()
		{
			this.b完了 = false;
			this.ct透明度カウンタ = new CCounter( 0, 255, this.n速度ms );
		}

		public CMActフェードアウト・透明度()
		{
			this.n速度ms = 4;
		}
		public CMActフェードアウト・透明度( int n速度ms )
		{
			this.n速度ms = n速度ms;
		}

		public override void On活性化( Device D3D9Device )
		{
			if( this.b活性化してる )
				return;

			this.ct透明度カウンタ = null;

			base.On活性化( D3D9Device );
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( ref this.ct透明度カウンタ );
			base.On非活性化();
		}
		public override int On進行()
		{
			if( this.b活性化してない ||
				this.ct透明度カウンタ == null )
				return 0;

			if( !this.b完了 )
			{
				this.ct透明度カウンタ.t進行();

				if( this.ct透明度カウンタ.b終了値に達した )
					this.b完了 = true;
			}
			return 0;
		}
		public void On描画( Device D3D9Device, CTexture txカバー )
		{
			if( this.b活性化してない ||
				txカバー == null ||
				this.ct透明度カウンタ == null )
				return;

			txカバー.vc拡大縮小倍率 = new Vector3(
				CTexture.sz論理画面.Width / (float) txカバー.sz画像サイズ.Width,
				CTexture.sz論理画面.Height / (float) txカバー.sz画像サイズ.Height,
				1.0f );
			txカバー.n透明度 = this.ct透明度カウンタ.n現在の値;
			txカバー.t2D描画( D3D9Device, 0, 0 );
		}

		protected CCounter ct透明度カウンタ = null;
		protected int n速度ms = 4;
	}
}
